#pragma once

#include "Config_Serial.h"
#include "LocDBList.h"
#include "MC6021.h"
#include "TrainDB.h"

#define POWER_ON 1
#define POWER_OFF 0

#define ACCESSORIES_MAX 256
#define SPEED_MAX 1024
#define SPEED_MULVAL 3
#define LOC_MAX 50;
#define DIRECTION_FWD 1
#define DIRECTION_REV 2
#define PEN_WIDTH 2
#define PEN_WIDTH_SLM 1
#define PEN_WIDTH_DBL 4
#define METER_LINEWIDTH 12
#define METER_LINEWIDTH2 24


int gLastSpeed = 0;
int gLocAddress = 3;
int gControlMode = 0;
int gCurrentLocID = 0;
int gCurrentLocSpeed = 0;
int gCurrentDirection = DIRECTION_FWD;



namespace RailuinoGUI {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Xml::Serialization;
	using namespace System::IO;
	using namespace System::Drawing;
	using namespace System::Drawing::Drawing2D;
	using namespace System::Collections::Generic;
	using namespace Microsoft::VisualBasic::FileIO;


	/// <summary>
	/// Form1 ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{

			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//

			gTypedAddr = 0;
			gLocList = gcnew List<LocData^>;
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

	protected: 



	private: System::Windows::Forms::ToolStrip^  toolStrip;
	private: System::Windows::Forms::ToolStripButton^  SButton_Close;


	private: System::Windows::Forms::ToolStripButton^  SButton_Power;



	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator1;

	private: System::IO::Ports::SerialPort^  serialPort;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator2;
	private: System::Windows::Forms::ToolStripButton^  SButton_Loc;

	private: System::Windows::Forms::ToolStripButton^  SButton_Acc;

	private: System::Windows::Forms::ToolStripButton^  SButton_CfgSerial;

	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator3;






private: System::Windows::Forms::Timer^  timerSpeed;

private: System::Windows::Forms::Timer^  timerDraw;
private: System::Windows::Forms::ListView^  listView1;
private: System::Windows::Forms::ColumnHeader^  columnHeader1;
private: System::Windows::Forms::Button^  button_SpeedReset;
private: System::Windows::Forms::Panel^  panelMessage;

private: System::Windows::Forms::Label^  label_Message;
private: System::Windows::Forms::Button^  button_AnyLocs;


private: System::Windows::Forms::Button^  button_F10;
private: System::Windows::Forms::Button^  button_F11;
private: System::Windows::Forms::Button^  button_F12;
private: System::Windows::Forms::Button^  button_F14;
private: System::Windows::Forms::Button^  button_F8;
private: System::Windows::Forms::Button^  button_F9;
private: System::Windows::Forms::Button^  button_F3;
private: System::Windows::Forms::Button^  button_F4;
private: System::Windows::Forms::Button^  button_F5;
private: System::Windows::Forms::Button^  button_F6;
private: System::Windows::Forms::Button^  button_F7;
private: System::Windows::Forms::Button^  button_F13;
private: System::Windows::Forms::Button^  button_F2;
private: System::Windows::Forms::Button^  button_REV;
private: System::Windows::Forms::Button^  button_FWD;
private: System::Windows::Forms::Button^  button_F1;

private: System::Windows::Forms::PictureBox^  MeterBox;
private: System::Windows::Forms::TrackBar^  AccelBar;
private: System::Windows::Forms::ImageList^  checkimgList;
private: System::Windows::Forms::ComboBox^  cBox_LocChange;
	private: System::Windows::Forms::Button^  button_NewLoc;
	private: System::Windows::Forms::Button^  button_DelLoc;
	private: System::Windows::Forms::ToolStripButton^  SButton_KPAD;
	private: System::Windows::Forms::Panel^  panel6021;

	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Button^  button6021_REV;

	private: System::Windows::Forms::Button^  button6021_FWD;

	private: System::Windows::Forms::Button^  button6021_F4;

	private: System::Windows::Forms::Button^  button6021_F3;

	private: System::Windows::Forms::Button^  button6021_F2;

	private: System::Windows::Forms::Button^  button6021_F1;

	private: System::Windows::Forms::TrackBar^  AccBar_6021;

	private: System::Windows::Forms::Label^  label_Addr;
private: System::Windows::Forms::Button^  button6021_0;

private: System::Windows::Forms::Button^  button6021_9;

private: System::Windows::Forms::Button^  button6021_8;

private: System::Windows::Forms::Button^  button6021_7;

private: System::Windows::Forms::Button^  button6021_6;

private: System::Windows::Forms::Button^  button6021_5;

private: System::Windows::Forms::Button^  button6021_4;

private: System::Windows::Forms::Button^  button6021_3;

private: System::Windows::Forms::Button^  button6021_2;

private: System::Windows::Forms::Button^  button6021_1;





















	private: System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>



#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->toolStrip = (gcnew System::Windows::Forms::ToolStrip());
			this->SButton_Close = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolStripSeparator1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->SButton_Power = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolStripSeparator2 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->SButton_Loc = (gcnew System::Windows::Forms::ToolStripButton());
			this->SButton_Acc = (gcnew System::Windows::Forms::ToolStripButton());
			this->SButton_KPAD = (gcnew System::Windows::Forms::ToolStripButton());
			this->toolStripSeparator3 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->SButton_CfgSerial = (gcnew System::Windows::Forms::ToolStripButton());
			this->serialPort = (gcnew System::IO::Ports::SerialPort(this->components));
			this->timerSpeed = (gcnew System::Windows::Forms::Timer(this->components));
			this->timerDraw = (gcnew System::Windows::Forms::Timer(this->components));
			this->listView1 = (gcnew System::Windows::Forms::ListView());
			this->columnHeader1 = (gcnew System::Windows::Forms::ColumnHeader());
			this->button_SpeedReset = (gcnew System::Windows::Forms::Button());
			this->checkimgList = (gcnew System::Windows::Forms::ImageList(this->components));
			this->panelMessage = (gcnew System::Windows::Forms::Panel());
			this->label_Message = (gcnew System::Windows::Forms::Label());
			this->button_AnyLocs = (gcnew System::Windows::Forms::Button());
			this->button_F10 = (gcnew System::Windows::Forms::Button());
			this->button_F11 = (gcnew System::Windows::Forms::Button());
			this->button_F12 = (gcnew System::Windows::Forms::Button());
			this->button_F14 = (gcnew System::Windows::Forms::Button());
			this->button_F8 = (gcnew System::Windows::Forms::Button());
			this->button_F9 = (gcnew System::Windows::Forms::Button());
			this->button_F3 = (gcnew System::Windows::Forms::Button());
			this->button_F4 = (gcnew System::Windows::Forms::Button());
			this->button_F5 = (gcnew System::Windows::Forms::Button());
			this->button_F6 = (gcnew System::Windows::Forms::Button());
			this->button_F7 = (gcnew System::Windows::Forms::Button());
			this->button_F13 = (gcnew System::Windows::Forms::Button());
			this->button_F2 = (gcnew System::Windows::Forms::Button());
			this->button_REV = (gcnew System::Windows::Forms::Button());
			this->button_FWD = (gcnew System::Windows::Forms::Button());
			this->button_F1 = (gcnew System::Windows::Forms::Button());
			this->MeterBox = (gcnew System::Windows::Forms::PictureBox());
			this->AccelBar = (gcnew System::Windows::Forms::TrackBar());
			this->cBox_LocChange = (gcnew System::Windows::Forms::ComboBox());
			this->button_NewLoc = (gcnew System::Windows::Forms::Button());
			this->button_DelLoc = (gcnew System::Windows::Forms::Button());
			this->panel6021 = (gcnew System::Windows::Forms::Panel());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->button6021_REV = (gcnew System::Windows::Forms::Button());
			this->button6021_FWD = (gcnew System::Windows::Forms::Button());
			this->button6021_F4 = (gcnew System::Windows::Forms::Button());
			this->button6021_F3 = (gcnew System::Windows::Forms::Button());
			this->button6021_F2 = (gcnew System::Windows::Forms::Button());
			this->button6021_F1 = (gcnew System::Windows::Forms::Button());
			this->AccBar_6021 = (gcnew System::Windows::Forms::TrackBar());
			this->label_Addr = (gcnew System::Windows::Forms::Label());
			this->button6021_0 = (gcnew System::Windows::Forms::Button());
			this->button6021_9 = (gcnew System::Windows::Forms::Button());
			this->button6021_8 = (gcnew System::Windows::Forms::Button());
			this->button6021_7 = (gcnew System::Windows::Forms::Button());
			this->button6021_6 = (gcnew System::Windows::Forms::Button());
			this->button6021_5 = (gcnew System::Windows::Forms::Button());
			this->button6021_4 = (gcnew System::Windows::Forms::Button());
			this->button6021_3 = (gcnew System::Windows::Forms::Button());
			this->button6021_2 = (gcnew System::Windows::Forms::Button());
			this->button6021_1 = (gcnew System::Windows::Forms::Button());
			this->toolStrip->SuspendLayout();
			this->panelMessage->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->MeterBox))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->AccelBar))->BeginInit();
			this->panel6021->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->AccBar_6021))->BeginInit();
			this->SuspendLayout();
			// 
			// toolStrip
			// 
			resources->ApplyResources(this->toolStrip, L"toolStrip");
			this->toolStrip->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(9) {this->SButton_Close, this->toolStripSeparator1, 
				this->SButton_Power, this->toolStripSeparator2, this->SButton_Loc, this->SButton_Acc, this->SButton_KPAD, this->toolStripSeparator3, 
				this->SButton_CfgSerial});
			this->toolStrip->Name = L"toolStrip";
			// 
			// SButton_Close
			// 
			this->SButton_Close->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			resources->ApplyResources(this->SButton_Close, L"SButton_Close");
			this->SButton_Close->Name = L"SButton_Close";
			this->SButton_Close->Click += gcnew System::EventHandler(this, &Form1::toolStripButton1_Click);
			// 
			// toolStripSeparator1
			// 
			this->toolStripSeparator1->Name = L"toolStripSeparator1";
			resources->ApplyResources(this->toolStripSeparator1, L"toolStripSeparator1");
			// 
			// SButton_Power
			// 
			resources->ApplyResources(this->SButton_Power, L"SButton_Power");
			this->SButton_Power->Name = L"SButton_Power";
			this->SButton_Power->Click += gcnew System::EventHandler(this, &Form1::toolStripButton3_Click);
			// 
			// toolStripSeparator2
			// 
			this->toolStripSeparator2->Name = L"toolStripSeparator2";
			resources->ApplyResources(this->toolStripSeparator2, L"toolStripSeparator2");
			// 
			// SButton_Loc
			// 
			this->SButton_Loc->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			resources->ApplyResources(this->SButton_Loc, L"SButton_Loc");
			this->SButton_Loc->Name = L"SButton_Loc";
			this->SButton_Loc->Tag = L"1";
			this->SButton_Loc->Click += gcnew System::EventHandler(this, &Form1::SButton_Loc_Click_1);
			// 
			// SButton_Acc
			// 
			this->SButton_Acc->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			resources->ApplyResources(this->SButton_Acc, L"SButton_Acc");
			this->SButton_Acc->Name = L"SButton_Acc";
			this->SButton_Acc->Tag = L"2";
			this->SButton_Acc->Click += gcnew System::EventHandler(this, &Form1::SButton_Loc_Click_1);
			// 
			// SButton_KPAD
			// 
			this->SButton_KPAD->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			resources->ApplyResources(this->SButton_KPAD, L"SButton_KPAD");
			this->SButton_KPAD->Name = L"SButton_KPAD";
			this->SButton_KPAD->Tag = L"3";
			this->SButton_KPAD->Click += gcnew System::EventHandler(this, &Form1::SButton_Loc_Click_1);
			// 
			// toolStripSeparator3
			// 
			this->toolStripSeparator3->Name = L"toolStripSeparator3";
			resources->ApplyResources(this->toolStripSeparator3, L"toolStripSeparator3");
			// 
			// SButton_CfgSerial
			// 
			this->SButton_CfgSerial->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			resources->ApplyResources(this->SButton_CfgSerial, L"SButton_CfgSerial");
			this->SButton_CfgSerial->Name = L"SButton_CfgSerial";
			this->SButton_CfgSerial->Click += gcnew System::EventHandler(this, &Form1::toolStripButton5_Click);
			// 
			// serialPort
			// 
			this->serialPort->BaudRate = 115200;
			this->serialPort->DataReceived += gcnew System::IO::Ports::SerialDataReceivedEventHandler(this, &Form1::serialPort_DataReceived);
			// 
			// timerSpeed
			// 
			this->timerSpeed->Interval = 2000;
			this->timerSpeed->Tick += gcnew System::EventHandler(this, &Form1::timerSpeed_Tick);
			// 
			// timerDraw
			// 
			this->timerDraw->Interval = 250;
			this->timerDraw->Tick += gcnew System::EventHandler(this, &Form1::timerDraw_Tick);
			// 
			// listView1
			// 
			this->listView1->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->listView1->CheckBoxes = true;
			this->listView1->Columns->AddRange(gcnew cli::array< System::Windows::Forms::ColumnHeader^  >(1) {this->columnHeader1});
			resources->ApplyResources(this->listView1, L"listView1");
			this->listView1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ListViewItem^  >(3) {(cli::safe_cast<System::Windows::Forms::ListViewItem^  >(resources->GetObject(L"listView1.Items"))), 
				(cli::safe_cast<System::Windows::Forms::ListViewItem^  >(resources->GetObject(L"listView1.Items1"))), (cli::safe_cast<System::Windows::Forms::ListViewItem^  >(resources->GetObject(L"listView1.Items2")))});
			this->listView1->MultiSelect = false;
			this->listView1->Name = L"listView1";
			this->listView1->OwnerDraw = true;
			this->listView1->TabStop = false;
			this->listView1->UseCompatibleStateImageBehavior = false;
			this->listView1->View = System::Windows::Forms::View::List;
			this->listView1->ItemChecked += gcnew System::Windows::Forms::ItemCheckedEventHandler(this, &Form1::listView1_ItemChecked);
			this->listView1->DrawItem += gcnew System::Windows::Forms::DrawListViewItemEventHandler(this, &Form1::listView1_DrawItem);
			// 
			// columnHeader1
			// 
			resources->ApplyResources(this->columnHeader1, L"columnHeader1");
			// 
			// button_SpeedReset
			// 
			resources->ApplyResources(this->button_SpeedReset, L"button_SpeedReset");
			this->button_SpeedReset->ImageList = this->checkimgList;
			this->button_SpeedReset->Name = L"button_SpeedReset";
			this->button_SpeedReset->TabStop = false;
			this->button_SpeedReset->Tag = L"0";
			this->button_SpeedReset->UseVisualStyleBackColor = true;
			this->button_SpeedReset->Click += gcnew System::EventHandler(this, &Form1::button_SpeedReset_Click);
			// 
			// checkimgList
			// 
			this->checkimgList->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"checkimgList.ImageStream")));
			this->checkimgList->TransparentColor = System::Drawing::Color::Lime;
			this->checkimgList->Images->SetKeyName(0, L"mark017.bmp");
			this->checkimgList->Images->SetKeyName(1, L"mark007.bmp");
			this->checkimgList->Images->SetKeyName(2, L"PICS_3dots.bmp");
			this->checkimgList->Images->SetKeyName(3, L"PICS_SIGNALRED.bmp");
			this->checkimgList->Images->SetKeyName(4, L"PICS_DEL.bmp");
			this->checkimgList->Images->SetKeyName(5, L"PICS_NEW.bmp");
			// 
			// panelMessage
			// 
			this->panelMessage->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->panelMessage->Controls->Add(this->label_Message);
			resources->ApplyResources(this->panelMessage, L"panelMessage");
			this->panelMessage->Name = L"panelMessage";
			// 
			// label_Message
			// 
			resources->ApplyResources(this->label_Message, L"label_Message");
			this->label_Message->Name = L"label_Message";
			// 
			// button_AnyLocs
			// 
			resources->ApplyResources(this->button_AnyLocs, L"button_AnyLocs");
			this->button_AnyLocs->ImageList = this->checkimgList;
			this->button_AnyLocs->Name = L"button_AnyLocs";
			this->button_AnyLocs->TabStop = false;
			this->button_AnyLocs->UseVisualStyleBackColor = true;
			this->button_AnyLocs->Click += gcnew System::EventHandler(this, &Form1::button_AnyLocs_Click);
			// 
			// button_F10
			// 
			resources->ApplyResources(this->button_F10, L"button_F10");
			this->button_F10->Name = L"button_F10";
			this->button_F10->TabStop = false;
			this->button_F10->Tag = L"10";
			this->button_F10->UseVisualStyleBackColor = true;
			this->button_F10->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F11
			// 
			resources->ApplyResources(this->button_F11, L"button_F11");
			this->button_F11->Name = L"button_F11";
			this->button_F11->TabStop = false;
			this->button_F11->Tag = L"11";
			this->button_F11->UseVisualStyleBackColor = true;
			this->button_F11->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F12
			// 
			resources->ApplyResources(this->button_F12, L"button_F12");
			this->button_F12->Name = L"button_F12";
			this->button_F12->TabStop = false;
			this->button_F12->Tag = L"12";
			this->button_F12->UseVisualStyleBackColor = true;
			this->button_F12->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F14
			// 
			resources->ApplyResources(this->button_F14, L"button_F14");
			this->button_F14->Name = L"button_F14";
			this->button_F14->TabStop = false;
			this->button_F14->Tag = L"14";
			this->button_F14->UseVisualStyleBackColor = true;
			this->button_F14->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F8
			// 
			resources->ApplyResources(this->button_F8, L"button_F8");
			this->button_F8->Name = L"button_F8";
			this->button_F8->TabStop = false;
			this->button_F8->Tag = L"8";
			this->button_F8->UseVisualStyleBackColor = true;
			this->button_F8->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F9
			// 
			resources->ApplyResources(this->button_F9, L"button_F9");
			this->button_F9->Name = L"button_F9";
			this->button_F9->TabStop = false;
			this->button_F9->Tag = L"9";
			this->button_F9->UseVisualStyleBackColor = true;
			this->button_F9->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F3
			// 
			resources->ApplyResources(this->button_F3, L"button_F3");
			this->button_F3->Name = L"button_F3";
			this->button_F3->TabStop = false;
			this->button_F3->Tag = L"3";
			this->button_F3->UseVisualStyleBackColor = true;
			this->button_F3->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F4
			// 
			resources->ApplyResources(this->button_F4, L"button_F4");
			this->button_F4->Name = L"button_F4";
			this->button_F4->TabStop = false;
			this->button_F4->Tag = L"4";
			this->button_F4->UseVisualStyleBackColor = true;
			this->button_F4->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F5
			// 
			resources->ApplyResources(this->button_F5, L"button_F5");
			this->button_F5->Name = L"button_F5";
			this->button_F5->TabStop = false;
			this->button_F5->Tag = L"5";
			this->button_F5->UseVisualStyleBackColor = true;
			this->button_F5->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F6
			// 
			resources->ApplyResources(this->button_F6, L"button_F6");
			this->button_F6->Name = L"button_F6";
			this->button_F6->TabStop = false;
			this->button_F6->Tag = L"6";
			this->button_F6->UseVisualStyleBackColor = true;
			this->button_F6->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F7
			// 
			resources->ApplyResources(this->button_F7, L"button_F7");
			this->button_F7->Name = L"button_F7";
			this->button_F7->TabStop = false;
			this->button_F7->Tag = L"7";
			this->button_F7->UseVisualStyleBackColor = true;
			this->button_F7->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F13
			// 
			resources->ApplyResources(this->button_F13, L"button_F13");
			this->button_F13->Name = L"button_F13";
			this->button_F13->TabStop = false;
			this->button_F13->Tag = L"13";
			this->button_F13->UseVisualStyleBackColor = true;
			this->button_F13->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_F2
			// 
			resources->ApplyResources(this->button_F2, L"button_F2");
			this->button_F2->Name = L"button_F2";
			this->button_F2->TabStop = false;
			this->button_F2->Tag = L"2";
			this->button_F2->UseVisualStyleBackColor = true;
			this->button_F2->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// button_REV
			// 
			resources->ApplyResources(this->button_REV, L"button_REV");
			this->button_REV->Name = L"button_REV";
			this->button_REV->TabStop = false;
			this->button_REV->Tag = L"1";
			this->button_REV->UseVisualStyleBackColor = true;
			this->button_REV->Click += gcnew System::EventHandler(this, &Form1::button_REV_Click);
			// 
			// button_FWD
			// 
			resources->ApplyResources(this->button_FWD, L"button_FWD");
			this->button_FWD->Name = L"button_FWD";
			this->button_FWD->TabStop = false;
			this->button_FWD->Tag = L"0";
			this->button_FWD->UseVisualStyleBackColor = true;
			this->button_FWD->Click += gcnew System::EventHandler(this, &Form1::button_REV_Click);
			// 
			// button_F1
			// 
			resources->ApplyResources(this->button_F1, L"button_F1");
			this->button_F1->Name = L"button_F1";
			this->button_F1->TabStop = false;
			this->button_F1->Tag = L"1";
			this->button_F1->UseVisualStyleBackColor = true;
			this->button_F1->Click += gcnew System::EventHandler(this, &Form1::button_F10_Click);
			// 
			// MeterBox
			// 
			resources->ApplyResources(this->MeterBox, L"MeterBox");
			this->MeterBox->Name = L"MeterBox";
			this->MeterBox->TabStop = false;
			this->MeterBox->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &Form1::MeterBox_Paint);
			// 
			// AccelBar
			// 
			resources->ApplyResources(this->AccelBar, L"AccelBar");
			this->AccelBar->BackColor = System::Drawing::SystemColors::Control;
			this->AccelBar->LargeChange = 1;
			this->AccelBar->Maximum = 5;
			this->AccelBar->Minimum = -5;
			this->AccelBar->Name = L"AccelBar";
			this->AccelBar->TabStop = false;
			this->AccelBar->TickStyle = System::Windows::Forms::TickStyle::Both;
			this->AccelBar->ValueChanged += gcnew System::EventHandler(this, &Form1::AccelBar_ValueChanged);
			// 
			// cBox_LocChange
			// 
			this->cBox_LocChange->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			resources->ApplyResources(this->cBox_LocChange, L"cBox_LocChange");
			this->cBox_LocChange->FormattingEnabled = true;
			this->cBox_LocChange->Items->AddRange(gcnew cli::array< System::Object^  >(2) {resources->GetString(L"cBox_LocChange.Items"), 
				resources->GetString(L"cBox_LocChange.Items1")});
			this->cBox_LocChange->Name = L"cBox_LocChange";
			this->cBox_LocChange->TabStop = false;
			this->cBox_LocChange->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::cBox_LocChange_SelectedIndexChanged);
			// 
			// button_NewLoc
			// 
			resources->ApplyResources(this->button_NewLoc, L"button_NewLoc");
			this->button_NewLoc->ImageList = this->checkimgList;
			this->button_NewLoc->Name = L"button_NewLoc";
			this->button_NewLoc->TabStop = false;
			this->button_NewLoc->UseVisualStyleBackColor = true;
			this->button_NewLoc->Click += gcnew System::EventHandler(this, &Form1::button_NewLoc_Click);
			// 
			// button_DelLoc
			// 
			resources->ApplyResources(this->button_DelLoc, L"button_DelLoc");
			this->button_DelLoc->ImageList = this->checkimgList;
			this->button_DelLoc->Name = L"button_DelLoc";
			this->button_DelLoc->TabStop = false;
			this->button_DelLoc->UseVisualStyleBackColor = true;
			this->button_DelLoc->Click += gcnew System::EventHandler(this, &Form1::button_DelLoc_Click);
			// 
			// panel6021
			// 
			this->panel6021->Controls->Add(this->label2);
			this->panel6021->Controls->Add(this->label1);
			this->panel6021->Controls->Add(this->button6021_REV);
			this->panel6021->Controls->Add(this->button6021_FWD);
			this->panel6021->Controls->Add(this->button6021_F4);
			this->panel6021->Controls->Add(this->button6021_F3);
			this->panel6021->Controls->Add(this->button6021_F2);
			this->panel6021->Controls->Add(this->button6021_F1);
			this->panel6021->Controls->Add(this->AccBar_6021);
			this->panel6021->Controls->Add(this->label_Addr);
			this->panel6021->Controls->Add(this->button6021_0);
			this->panel6021->Controls->Add(this->button6021_9);
			this->panel6021->Controls->Add(this->button6021_8);
			this->panel6021->Controls->Add(this->button6021_7);
			this->panel6021->Controls->Add(this->button6021_6);
			this->panel6021->Controls->Add(this->button6021_5);
			this->panel6021->Controls->Add(this->button6021_4);
			this->panel6021->Controls->Add(this->button6021_3);
			this->panel6021->Controls->Add(this->button6021_2);
			this->panel6021->Controls->Add(this->button6021_1);
			resources->ApplyResources(this->panel6021, L"panel6021");
			this->panel6021->Name = L"panel6021";
			// 
			// label2
			// 
			resources->ApplyResources(this->label2, L"label2");
			this->label2->Name = L"label2";
			// 
			// label1
			// 
			resources->ApplyResources(this->label1, L"label1");
			this->label1->Name = L"label1";
			// 
			// button6021_REV
			// 
			this->button6021_REV->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_REV, L"button6021_REV");
			this->button6021_REV->Name = L"button6021_REV";
			this->button6021_REV->TabStop = false;
			this->button6021_REV->Tag = L"1";
			this->button6021_REV->UseVisualStyleBackColor = false;
			this->button6021_REV->Click += gcnew System::EventHandler(this, &Form1::button6021_REV_Click);
			// 
			// button6021_FWD
			// 
			this->button6021_FWD->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_FWD, L"button6021_FWD");
			this->button6021_FWD->Name = L"button6021_FWD";
			this->button6021_FWD->TabStop = false;
			this->button6021_FWD->Tag = L"0";
			this->button6021_FWD->UseVisualStyleBackColor = false;
			this->button6021_FWD->Click += gcnew System::EventHandler(this, &Form1::button6021_REV_Click);
			// 
			// button6021_F4
			// 
			this->button6021_F4->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_F4, L"button6021_F4");
			this->button6021_F4->Name = L"button6021_F4";
			this->button6021_F4->TabStop = false;
			this->button6021_F4->Tag = L"4";
			this->button6021_F4->UseVisualStyleBackColor = false;
			this->button6021_F4->Click += gcnew System::EventHandler(this, &Form1::button6021_F4_Click);
			// 
			// button6021_F3
			// 
			this->button6021_F3->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_F3, L"button6021_F3");
			this->button6021_F3->Name = L"button6021_F3";
			this->button6021_F3->TabStop = false;
			this->button6021_F3->Tag = L"3";
			this->button6021_F3->UseVisualStyleBackColor = false;
			this->button6021_F3->Click += gcnew System::EventHandler(this, &Form1::button6021_F4_Click);
			// 
			// button6021_F2
			// 
			this->button6021_F2->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_F2, L"button6021_F2");
			this->button6021_F2->Name = L"button6021_F2";
			this->button6021_F2->TabStop = false;
			this->button6021_F2->Tag = L"2";
			this->button6021_F2->UseVisualStyleBackColor = false;
			this->button6021_F2->Click += gcnew System::EventHandler(this, &Form1::button6021_F4_Click);
			// 
			// button6021_F1
			// 
			this->button6021_F1->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_F1, L"button6021_F1");
			this->button6021_F1->Name = L"button6021_F1";
			this->button6021_F1->TabStop = false;
			this->button6021_F1->Tag = L"1";
			this->button6021_F1->UseVisualStyleBackColor = false;
			this->button6021_F1->Click += gcnew System::EventHandler(this, &Form1::button6021_F4_Click);
			// 
			// AccBar_6021
			// 
			this->AccBar_6021->LargeChange = 1;
			resources->ApplyResources(this->AccBar_6021, L"AccBar_6021");
			this->AccBar_6021->Maximum = 16;
			this->AccBar_6021->Name = L"AccBar_6021";
			this->AccBar_6021->Scroll += gcnew System::EventHandler(this, &Form1::AccBar_6021_Scroll);
			// 
			// label_Addr
			// 
			this->label_Addr->BackColor = System::Drawing::Color::Black;
			this->label_Addr->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			resources->ApplyResources(this->label_Addr, L"label_Addr");
			this->label_Addr->ForeColor = System::Drawing::Color::Red;
			this->label_Addr->Name = L"label_Addr";
			// 
			// button6021_0
			// 
			this->button6021_0->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_0, L"button6021_0");
			this->button6021_0->Name = L"button6021_0";
			this->button6021_0->TabStop = false;
			this->button6021_0->Tag = L"0";
			this->button6021_0->UseVisualStyleBackColor = false;
			this->button6021_0->Click += gcnew System::EventHandler(this, &Form1::button10_Click);
			// 
			// button6021_9
			// 
			this->button6021_9->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_9, L"button6021_9");
			this->button6021_9->Name = L"button6021_9";
			this->button6021_9->TabStop = false;
			this->button6021_9->Tag = L"9";
			this->button6021_9->UseVisualStyleBackColor = false;
			this->button6021_9->Click += gcnew System::EventHandler(this, &Form1::button10_Click);
			// 
			// button6021_8
			// 
			this->button6021_8->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_8, L"button6021_8");
			this->button6021_8->Name = L"button6021_8";
			this->button6021_8->TabStop = false;
			this->button6021_8->Tag = L"8";
			this->button6021_8->UseVisualStyleBackColor = false;
			this->button6021_8->Click += gcnew System::EventHandler(this, &Form1::button10_Click);
			// 
			// button6021_7
			// 
			this->button6021_7->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_7, L"button6021_7");
			this->button6021_7->Name = L"button6021_7";
			this->button6021_7->TabStop = false;
			this->button6021_7->Tag = L"7";
			this->button6021_7->UseVisualStyleBackColor = false;
			this->button6021_7->Click += gcnew System::EventHandler(this, &Form1::button10_Click);
			// 
			// button6021_6
			// 
			this->button6021_6->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_6, L"button6021_6");
			this->button6021_6->Name = L"button6021_6";
			this->button6021_6->TabStop = false;
			this->button6021_6->Tag = L"6";
			this->button6021_6->UseVisualStyleBackColor = false;
			this->button6021_6->Click += gcnew System::EventHandler(this, &Form1::button10_Click);
			// 
			// button6021_5
			// 
			this->button6021_5->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_5, L"button6021_5");
			this->button6021_5->Name = L"button6021_5";
			this->button6021_5->TabStop = false;
			this->button6021_5->Tag = L"5";
			this->button6021_5->UseVisualStyleBackColor = false;
			this->button6021_5->Click += gcnew System::EventHandler(this, &Form1::button10_Click);
			// 
			// button6021_4
			// 
			this->button6021_4->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_4, L"button6021_4");
			this->button6021_4->Name = L"button6021_4";
			this->button6021_4->TabStop = false;
			this->button6021_4->Tag = L"4";
			this->button6021_4->UseVisualStyleBackColor = false;
			this->button6021_4->Click += gcnew System::EventHandler(this, &Form1::button10_Click);
			// 
			// button6021_3
			// 
			this->button6021_3->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_3, L"button6021_3");
			this->button6021_3->Name = L"button6021_3";
			this->button6021_3->TabStop = false;
			this->button6021_3->Tag = L"3";
			this->button6021_3->UseVisualStyleBackColor = false;
			this->button6021_3->Click += gcnew System::EventHandler(this, &Form1::button10_Click);
			// 
			// button6021_2
			// 
			this->button6021_2->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_2, L"button6021_2");
			this->button6021_2->Name = L"button6021_2";
			this->button6021_2->TabStop = false;
			this->button6021_2->Tag = L"2";
			this->button6021_2->UseVisualStyleBackColor = false;
			this->button6021_2->Click += gcnew System::EventHandler(this, &Form1::button10_Click);
			// 
			// button6021_1
			// 
			this->button6021_1->BackColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(192)), 
				static_cast<System::Int32>(static_cast<System::Byte>(0)));
			resources->ApplyResources(this->button6021_1, L"button6021_1");
			this->button6021_1->Name = L"button6021_1";
			this->button6021_1->TabStop = false;
			this->button6021_1->Tag = L"1";
			this->button6021_1->UseVisualStyleBackColor = false;
			this->button6021_1->Click += gcnew System::EventHandler(this, &Form1::button10_Click);
			// 
			// Form1
			// 
			resources->ApplyResources(this, L"$this");
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->Controls->Add(this->panel6021);
			this->Controls->Add(this->listView1);
			this->Controls->Add(this->button_DelLoc);
			this->Controls->Add(this->button_NewLoc);
			this->Controls->Add(this->cBox_LocChange);
			this->Controls->Add(this->button_SpeedReset);
			this->Controls->Add(this->panelMessage);
			this->Controls->Add(this->button_AnyLocs);
			this->Controls->Add(this->button_F10);
			this->Controls->Add(this->button_F11);
			this->Controls->Add(this->button_F12);
			this->Controls->Add(this->button_F14);
			this->Controls->Add(this->button_F8);
			this->Controls->Add(this->button_F9);
			this->Controls->Add(this->button_F3);
			this->Controls->Add(this->button_F4);
			this->Controls->Add(this->button_F5);
			this->Controls->Add(this->button_F6);
			this->Controls->Add(this->button_F7);
			this->Controls->Add(this->button_F13);
			this->Controls->Add(this->button_F2);
			this->Controls->Add(this->button_REV);
			this->Controls->Add(this->button_FWD);
			this->Controls->Add(this->button_F1);
			this->Controls->Add(this->MeterBox);
			this->Controls->Add(this->AccelBar);
			this->Controls->Add(this->toolStrip);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MaximizeBox = false;
			this->Name = L"Form1";
			this->SizeGripStyle = System::Windows::Forms::SizeGripStyle::Hide;
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &Form1::Form1_FormClosing);
			this->KeyDown += gcnew System::Windows::Forms::KeyEventHandler(this, &Form1::Form1_KeyDown);
			this->toolStrip->ResumeLayout(false);
			this->toolStrip->PerformLayout();
			this->panelMessage->ResumeLayout(false);
			this->panelMessage->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->MeterBox))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->AccelBar))->EndInit();
			this->panel6021->ResumeLayout(false);
			this->panel6021->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->AccBar_6021))->EndInit();
			this->ResumeLayout(false);

		}
#pragma endregion

		private:
			AppSetting^ gAppSettings;
		private:
			List<LocData^>^ gLocList;
		private:
			String^ gLocName;
		private:
			int gTypedAddr;

		private:
		void SendCommand(String^ inCommandText)
		{
			 if( serialPort->IsOpen)
			 {
				 serialPort->WriteLine(inCommandText);
				 label_Message->Text = "SEND: "+ inCommandText;
			 }
			 else
			 {
				 label_Message->Text = "Serial Port is not available";
			 }
		}

		void RAILUINO_setLocoSpeed(int inAddress, int inSpeed)
		{
			String^ aCommandText;

			aCommandText = "setLocoSpeed(" + inAddress.ToString() + "," + inSpeed.ToString() + ")";

			SendCommand(aCommandText);

		}

		void RAILUINO_accelerateLoco(int inAddress)
		{
			String^ aCommandText;

			aCommandText = "accelerateLoco(" + inAddress.ToString() + ")";

			SendCommand(aCommandText);
		}
			
		void RAILUINO_decelerateLoco(int inAddress)
		{
			String^ aCommandText;

			aCommandText = "decelerateLoco(" + inAddress.ToString() + ")";

			SendCommand(aCommandText);
		}			

		void RAILUINO_toggleLocoDirection(int inAddress)
		{
			String^ aCommandText;

			aCommandText = "toggleLocoDirection(" + inAddress.ToString() + ")";

			SendCommand(aCommandText);
		}	

		void RAILUINO_toggleLocoFunction(int inAddress, int inFunction)
		{
			String^ aCommandText;

			aCommandText = "toggleLocoFunction(" + inAddress.ToString()+ "," + inFunction.ToString() + ")";

			SendCommand(aCommandText);
		}

		void RAILUINO_setLocoFunction(int inAddress, int inFunction, int inPower)
		{
			String^ aCommandText;

			aCommandText = "setLocoFunction(" + inAddress.ToString()+ "," + inFunction.ToString() + "," + inPower.ToString() + ")";

			SendCommand(aCommandText);
		}
		
		void RAILUINO_setLocoDirection(int inAddress, int inDirection)
		{
			String^ aCommandText;

			aCommandText = "setLocoDirection(" + inAddress.ToString() + "," + inDirection.ToString() + ")";

			SendCommand(aCommandText);

		}
			
		void RAILUINO_setTurnout(int inAddress, int inDirection)
		{
			String^ aCommandText;
			int aCalcAddress;

			aCalcAddress = 0x2FFF + inAddress;

			aCommandText = "setTurnout(" + aCalcAddress.ToString() + "," + inDirection.ToString() + ")";

			SendCommand(aCommandText);

		}
			
		void RAILUINO_setPower(int inPower)
		{
			String^ aCommandText;

			aCommandText = "setPower(" + inPower.ToString() + ")";

			SendCommand(aCommandText);

			gControlMode = inPower;

		}			

	public: 
		void WriteXMLSetting()
		{
			//XmlSerializerĂяo
			XmlSerializer^ serializer = gcnew XmlSerializer(AppSetting::typeid);
			//t@C
			FileStream^ fs = gcnew FileStream(Application::StartupPath + "\\settings.xml", FileMode::Create);
			//
			serializer->Serialize(fs, gAppSettings);  //sclsSampleClass̃CX^X
			//t@C
			fs->Close();
		}

	public: 
		bool ReadXMLSetting()
		{
			bool retVal = false;

			/* ݂Ȃꍇ͐ */
			if (gAppSettings == nullptr)
			{
				gAppSettings = gcnew AppSetting();
			}

			//ݒt@CƂ̂ݓǂݍ݂܂B
			if (File::Exists(Application::StartupPath + "\\settings.xml"))
			{
				//XmlSerializerĂяo
				XmlSerializer^ serializer = gcnew XmlSerializer(AppSetting::typeid);
				//t@CJ
				FileStream^ fs = gcnew FileStream(Application::StartupPath + "\\settings.xml", FileMode::Open);

				//ǂݍ
				gAppSettings = (AppSetting^)serializer->Deserialize(fs);
				//t@C
				fs->Close();

				retVal = true;
			}
			else
			{
				gAppSettings->mPortName = "COM1";
				gAppSettings->mBaudrate = 115200;
			}

			return retVal;
		}

	private:
		void WriteLocDB(void)
		{
			int i;

			//t@C
			StreamWriter^ aStrWriter = gcnew StreamWriter(Application::StartupPath + "\\LocDB.dat", false);

			for( i = 0; i < gLocList->Count; i++)
			{
				aStrWriter->WriteLine("{0},{1},{2},{3}",gLocList[i]->mLocAddr, gLocList[i]->mLocName, gLocList[i]->mLocItemNo, gLocList[i]->mLocManufacture);

			}

			aStrWriter->Close();
		}

	private:
		void ReadLocDB(void)
		{

			array <String^>^ aFields;

			//ݒt@CƂ̂ݓǂݍ݂܂B
			if (File::Exists(Application::StartupPath + "\\LocDB.dat"))
			{

				TextFieldParser^ aParser = gcnew TextFieldParser(Application::StartupPath + "\\LocDB.dat");
				aParser->TextFieldType = FieldType::Delimited;
		        aParser->SetDelimiters(",");

				while( aParser->EndOfData == false)
				{

					/* ͏ */
					LocData^ aItem = gcnew LocData();

					aFields = aParser->ReadFields();

					aItem->mLocAddr = int::Parse(aFields[0]);
					aItem->mLocName = aFields[1];
					aItem->mLocItemNo = int::Parse(aFields[2]);
					aItem->mLocManufacture = aFields[3];
					aItem->mFunctionTable = gcnew array<int>(16);

					/* ǉ */
					gLocList->Add(aItem);
				}

				aParser->Close();

			}
			else
			{
					LocData^ aItem = gcnew LocData();
					aItem->mLocAddr = 3;
					aItem->mLocName = "DB ICE3";
					aItem->mLocItemNo = 57305;
					aItem->mLocManufacture = "PIKO";
					aItem->mFunctionTable = gcnew array<int>(16);

					/* ǉ */
					gLocList->Add(aItem);
			}

		}

	private:
		void UpdateLocDisplay(void)
		{
			int i;
			int aSelectIndex;

			aSelectIndex = cBox_LocChange->SelectedIndex;

			cBox_LocChange->Items->Clear();

			for( i = 0; i < gLocList->Count; i++)
			{
				cBox_LocChange->Items->Add(gLocList[i]->mLocAddr.ToString() + ": " + gLocList[i]->mLocName);
			}

			if( aSelectIndex < 0)
			{
				aSelectIndex = 0;
			}

			cBox_LocChange->SelectedIndex = aSelectIndex;

		}


	private:
		void ControlAvailability(bool inAvailable)
		{
			button_F1->Enabled = inAvailable;
			button_F2->Enabled = inAvailable;
			button_F3->Enabled = inAvailable;
			button_F4->Enabled = inAvailable;
			button_F5->Enabled = inAvailable;
			button_F6->Enabled = inAvailable;
			button_F7->Enabled = inAvailable;
			button_F8->Enabled = inAvailable;
			button_F9->Enabled = inAvailable;
			button_F10->Enabled = inAvailable;
			button_F11->Enabled = inAvailable;
			button_F12->Enabled = inAvailable;
			button_F13->Enabled = inAvailable;
			button_F14->Enabled = inAvailable;
			button_FWD->Enabled = inAvailable;
			button_REV->Enabled = inAvailable;
			button_SpeedReset->Enabled = inAvailable;
			cBox_LocChange->Enabled = inAvailable;
			listView1->Enabled = inAvailable;
			button_AnyLocs->Enabled = inAvailable;
			timerSpeed->Enabled = inAvailable;
			timerDraw->Enabled = inAvailable;
			AccelBar->Enabled = inAvailable;
			button_NewLoc->Enabled = inAvailable;
			button_DelLoc->Enabled = inAvailable;
			SButton_Loc->Enabled = inAvailable;
			SButton_Acc->Enabled = inAvailable;
			SButton_KPAD->Enabled = inAvailable;

			/* 6021KeyPad */
			button6021_0->Enabled = inAvailable;
			button6021_1->Enabled = inAvailable;
			button6021_2->Enabled = inAvailable;
			button6021_3->Enabled = inAvailable;
			button6021_4->Enabled = inAvailable;
			button6021_5->Enabled = inAvailable;
			button6021_6->Enabled = inAvailable;
			button6021_7->Enabled = inAvailable;
			button6021_8->Enabled = inAvailable;
			button6021_9->Enabled = inAvailable;
			button6021_F1->Enabled = inAvailable;
			button6021_F2->Enabled = inAvailable;
			button6021_F3->Enabled = inAvailable;
			button6021_F4->Enabled = inAvailable;
			button6021_FWD->Enabled = inAvailable;
			button6021_REV->Enabled = inAvailable;
			AccBar_6021->Enabled = inAvailable;


		}

	private: System::Void serialPort_DataReceived(System::Object^  sender, System::IO::Ports::SerialDataReceivedEventArgs^  e) {

				 if( serialPort->IsOpen)
				 {
					 /* Mf[^\ */
					// termsBox->AppendText("RECV: " + serialPort->ReadExisting() + "\r\n");
				 }
			 }

private: System::Void toolStripButton3_Click(System::Object^  sender, System::EventArgs^  e) {

			   array<String^>^ aSerialPorts;

			   aSerialPorts = serialPort->GetPortNames();

			   if( aSerialPorts->Length > 0)
			   {
				 if( serialPort->IsOpen == false)
				 {
					 try
					 {
						serialPort->Open();
					 }
					catch ( ArgumentException^ e ) {
						label_Message->Text = e->Message;
						return;
					}
				 }


				 if( serialPort->IsOpen)
				 {
					if( gControlMode == POWER_OFF)
					{
						/* Itɂ */
						RAILUINO_setPower(POWER_OFF);
						
						//҂
						System::Threading::Thread::Sleep(100);

						/* [ɓd */
						RAILUINO_setPower(POWER_ON);

						SButton_Power->Text = "STOP";
						ControlAvailability(true);

						UpdateLocDisplay();
					}
					else
					{
						RAILUINO_setPower(POWER_OFF);
						SButton_Power->Text = "START";
						ControlAvailability(false);
					}
				 }
				 else
				 {
					 label_Message->Text = "Serial Port is not available.";
				 }
			   }
			 else
			 {
				 label_Message->Text = "Not found Serial Port.";
			 }
		 }


private: System::Void toolStripButton1_Click(System::Object^  sender, System::EventArgs^  e) {
			 Close();
		 }


private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) {

			 int i;

			 /* 255܂ł̃ANZTo^ */
			 listView1->BeginUpdate();
			 listView1->Items->Clear();

			  for ( i = 1; i < ACCESSORIES_MAX; i++ )
			  {
				  ListViewItem^ listItem = gcnew ListViewItem(i.ToString());
				 listView1->Items->Add( listItem );
			  }
		      
			  listView1->EndUpdate();

			  /* XMLݒǂݍ */
			  ReadXMLSetting();

			  /* @֎DBǂݍ */
			  ReadLocDB();

			  /* ݒi[ */
			  serialPort->BaudRate = gAppSettings->mBaudrate;
			  serialPort->PortName = gAppSettings->mPortName;

			  /* tH[TCY𒼂 */
			  Form1::Width = 734;

			  /* ANZTʂƂȂ郊Xgr[B */
			 listView1->Visible = true;
			 listView1->Size = System::Drawing::Size(0, 0);

			 /* L[pbhB */
			 panel6021->Visible = false;
			 panel6021->Left = 14;
			 panel6021->Top = 40;

			 /* p[It */
			 gControlMode = POWER_OFF;

			 /* ͑łȂ悤ɂ */
			 ControlAvailability(false);

		 }

		 
private: System::Void toolStripButton5_Click(System::Object^  sender, System::EventArgs^  e) {

			 /* ݒtH[J */
			 Config_Serial^ aForm = gcnew Config_Serial;

			 aForm->cBox_SerialPort->Items->Clear();
			 aForm->cBox_SerialPort->Items->AddRange(serialPort->GetPortNames());
			 aForm->cBox_SerialPort->Text = serialPort->PortName;
			 aForm->cBox_Baudrate->Text =  serialPort->BaudRate.ToString();
			 aForm->ShowDialog(this);

			//ꂽ{^ʂ̏ 
			 if (aForm->DialogResult == System::Windows::Forms::DialogResult::OK) 
			 {
				 serialPort->Close();
				 serialPort->PortName = aForm->cBox_SerialPort->Text;
				 serialPort->BaudRate = int::Parse(aForm->cBox_Baudrate->Text);
				 serialPort->Open();
			 }

			 //tH[̉ 
			 delete aForm; 


		 }
private: System::Void button_F10_Click(System::Object^  sender, System::EventArgs^  e) {
			
			
			Button^ aButton = (Button^)sender; 
			int aTag;
			int aPower;

			aTag = int::Parse(aButton->Tag->ToString());

			aPower = gLocList[cBox_LocChange->SelectedIndex]->mFunctionTable[aTag];

			if( aPower < 2)
			{
				aPower = Math::Abs(aPower - 1);

				 /* [^Et@NV */
				RAILUINO_setLocoFunction(gLocAddress, aTag, aPower);

				/* Xgɔf */
				gLocList[cBox_LocChange->SelectedIndex]->mFunctionTable[aTag] = aPower;

			}
			else
			{
				 /* I^l^Et@NV */
				RAILUINO_setLocoFunction(gLocAddress, aTag, 1);
				
				//҂
				System::Threading::Thread::Sleep(1000);
				
				/* ɐ؂ */
				RAILUINO_setLocoFunction(gLocAddress, aTag, 0);

			}
		 }

private: System::Void listView1_ItemChecked(System::Object^  sender, System::Windows::Forms::ItemCheckedEventArgs^  e) {

			 /* ANZT̑쏈 */

			 int aAddress;

			 ListViewItem^ aItem = (ListViewItem^)e->Item;

			 aAddress = int::Parse(aItem->Text);

			 if( aItem->Checked)
			 {
				 RAILUINO_setTurnout(aAddress, 1);
			 }
			 else
			 {
				 RAILUINO_setTurnout(aAddress, 0);
			 }

		 }

	 
private: System::Void Form1_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {

			/* ݂Ȃꍇ͐ */
			if (gAppSettings == nullptr)
			{
				gAppSettings = gcnew AppSetting();
			}

			/* ݒi[ */
			gAppSettings->mBaudrate = serialPort->BaudRate;
			gAppSettings->mPortName = serialPort->PortName;

			/* XMLۑ */
			WriteXMLSetting();
			WriteLocDB();

			if( serialPort->IsOpen)
			{
					RAILUINO_setPower(POWER_OFF);
					//҂
					System::Threading::Thread::Sleep(100);
			}

			/* VA|[g */
			serialPort->Close();


		 }
private: System::Void button_REV_Click(System::Object^  sender, System::EventArgs^  e) {

			
			Button^ aButton = (Button^)sender; 
			int aTag;

			aTag = int::Parse(aButton->Tag->ToString());
		
			 /* is */
			switch(aTag)
			{
				case 0: RAILUINO_setLocoDirection(gLocAddress, DIRECTION_FWD); break;
				case 1: RAILUINO_setLocoDirection(gLocAddress, DIRECTION_REV); break;
			}


		 }

private: System::Void MeterBox_Paint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e) {

			int aX, aY, bX, bY;

			int cX, cY;
			int aTheta = 0;
			int aR;
			int i;
			String^ aTextNotch;
			

			cX = 160;
			cY = 160;
			aR = 160;

			 /* ` */

			 Graphics^ aCanvas = e->Graphics;

			 //yIuWFNg̍쐬
			 Pen^ aPen = gcnew Pen(Color::Black);
			 aPen->Width = PEN_WIDTH_DBL;

			 //yIuWFNg̍쐬
			 Pen^ aPenPin = gcnew Pen(Color::Red);

			 //(A`GCAXꂽ^O)w肷
			 aCanvas->SmoothingMode = SmoothingMode::AntiAlias;


			 /* ׂ` */
			 aPenPin->Width = PEN_WIDTH_SLM;
			for( i = 0; i <= 24; i++)
			{
				aTheta = i + 6;
				aX = cX + Convert::ToInt32(aR * Math::Cos((aTheta - 27) * 2 * Math::PI / 36));
				aY = cY + Convert::ToInt32(aR * Math::Sin((aTheta - 27) * 2 * Math::PI / 36));
				bX = cX + Convert::ToInt32((aR - METER_LINEWIDTH) * Math::Cos((aTheta - 27) * 2 * Math::PI / 36));
				bY = cY + Convert::ToInt32((aR - METER_LINEWIDTH) * Math::Sin((aTheta - 27) * 2 * Math::PI / 36));

				 //`
				 aCanvas->DrawLine(aPen, aX, aY, bX, bY);
			}

			 /* ` */
			 aPenPin->Width = PEN_WIDTH;
			for( i = 0; i <= 6; i++)
			{
				aTheta = i * 4 + 6;
				aX = cX + Convert::ToInt32(aR * Math::Cos((aTheta - 27) * 2 * Math::PI / 36));
				aY = cY + Convert::ToInt32(aR * Math::Sin((aTheta - 27) * 2 * Math::PI / 36));
				bX = cX + Convert::ToInt32((aR - METER_LINEWIDTH2) * Math::Cos((aTheta - 27) * 2 * Math::PI / 36));
				bY = cY + Convert::ToInt32((aR - METER_LINEWIDTH2) * Math::Sin((aTheta - 27) * 2 * Math::PI / 36));

				 //`
				 aCanvas->DrawLine(aPen, aX, aY, bX, bY);
			}

			/* j`(240degAItZbg60deg) */
			aTheta = ((gCurrentLocSpeed * 2400) / 1024) + 600;

			/* j̈ʒuZ */
			bX = cX + Convert::ToInt32(aR * Math::Cos((aTheta - 2700) * 2 * Math::PI / 3600));
			bY = cY + Convert::ToInt32(aR * Math::Sin((aTheta - 2700) * 2 * Math::PI / 3600));
			
			//`
			aCanvas->DrawLine(aPenPin, cX, cY, bX, bY);

			/* n */
			System::Drawing::Font^ aDrawFont = gcnew System::Drawing::Font( "Arial",12 );
			StringFormat^ aDrawFormat = gcnew StringFormat;

			aDrawFormat->Alignment = StringAlignment::Center;
			aCanvas->DrawString("km/h", aDrawFont, Brushes::Black, 160, 200, aDrawFormat);

			if( gControlMode == POWER_OFF)
			{
				aCanvas->DrawString("Welcome to on board!", aDrawFont, Brushes::Red, 160, 260, aDrawFormat);
			}
			else
			{
				aCanvas->DrawString("Adr:" + gLocAddress.ToString() + " - " + gLocName, aDrawFont, Brushes::Red, 160, 260, aDrawFormat);
			}

			 /* mb`\ؑ */
			 switch( AccelBar->Value)
			 {
				 case -5: aTextNotch = "B5"; break;
				 case -4: aTextNotch = "B4"; break;
				 case -3: aTextNotch = "B3"; break;
				 case -2: aTextNotch = "B2"; break;
				 case -1: aTextNotch = "B1"; break;
				 case 0: aTextNotch = "N"; break;
				 case 1: aTextNotch = "P1"; break;
				 case 2: aTextNotch = "P2"; break;
				 case 3: aTextNotch = "P3"; break;
				 case 4: aTextNotch = "P4"; break;
				 case 5: aTextNotch = "P5"; break;
			 }
			aCanvas->DrawString(aTextNotch, aDrawFont, Brushes::Black, 160, 230, aDrawFormat);


			/* x\ */
			System::Drawing::Font^ aDrawFontMeter = gcnew System::Drawing::Font( "Arial", 15);
			aCanvas->DrawString("0", aDrawFontMeter, Brushes::Black, 50, 210);
			aCanvas->DrawString("50", aDrawFontMeter, Brushes::Black, 30, 130);
			aCanvas->DrawString("100", aDrawFontMeter, Brushes::Black, 70, 60);
			aCanvas->DrawString("150", aDrawFontMeter, Brushes::Black, 140, 30);
			aCanvas->DrawString("200", aDrawFontMeter, Brushes::Black, 210, 60);
			aCanvas->DrawString("250", aDrawFontMeter, Brushes::Black, 250, 130);
			aCanvas->DrawString("300", aDrawFontMeter, Brushes::Black, 230, 210);

			delete aPen;
			delete aPenPin;
			delete aDrawFont;

		 }

private: System::Void timerSpeed_Tick(System::Object^  sender, System::EventArgs^  e) {

			 if( gLastSpeed != gCurrentLocSpeed)
			 {
				 /* xZbg */
				 RAILUINO_setLocoSpeed(gLocAddress, gCurrentLocSpeed);
			 }

			 gLastSpeed = gCurrentLocSpeed;

		 }
private: System::Void button_SpeedReset_Click(System::Object^  sender, System::EventArgs^  e) {
			 AccelBar->Value = 0;
			 gCurrentLocSpeed = 0;

			 /* xZbg */
			 RAILUINO_setLocoSpeed(gLocAddress, gCurrentLocSpeed);

			 /* [^[XV */
			 MeterBox->Refresh();

		 }
private: System::Void timerDraw_Tick(System::Object^  sender, System::EventArgs^  e) {
			 
			 int aLastSpeed;

			 aLastSpeed = gCurrentLocSpeed;

			 /* Vx̉Z */
			 gCurrentLocSpeed = gCurrentLocSpeed + AccelBar->Value * SPEED_MULVAL;

			 if( gCurrentLocSpeed > SPEED_MAX)
			 {
				 gCurrentLocSpeed = SPEED_MAX;
			 }
			 else if(gCurrentLocSpeed < 0)
			 {
				 gCurrentLocSpeed = 0;
			 }

			 /* [^[XV */
			 MeterBox->Refresh();

		 }
private: System::Void listView1_DrawItem(System::Object^  sender, System::Windows::Forms::DrawListViewItemEventArgs^  e) {
			/**/

			 Graphics^ aCanvas = e->Graphics;


			 if( e->Item->Checked)
			 {
				 checkimgList->Draw(aCanvas, Point(e->Bounds.Left, e->Bounds.Top), 1);
			 }
			 else
			 {
				 checkimgList->Draw(aCanvas, Point(e->Bounds.Left, e->Bounds.Top), 0);
			 }

			  int textOffset = 16; 
			  Rectangle rText = e->Bounds;
			  rText.Offset(textOffset, 0);
			  rText.Width -= textOffset;

			  e->Graphics->DrawString(e->Item->Text, e->Item->Font, Brushes::Black, rText);

		 }


private: System::Void cBox_LocChange_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {
			 
			 gLocAddress = gLocList[cBox_LocChange->SelectedIndex]->mLocAddr;
			 gLocName = gLocList[cBox_LocChange->SelectedIndex]->mLocName;

			 /* [^[XV */
			 MeterBox->Refresh();

		 }


private: System::Void AccelBar_ValueChanged(System::Object^  sender, System::EventArgs^  e) {
 			 /* [^[XV */
			 MeterBox->Refresh();

		 }
private: System::Void button_AnyLocs_Click(System::Object^  sender, System::EventArgs^  e) {

			 /* @֎ԐݒtH[J */
			 LocDBList^ aForm = gcnew LocDBList;

			 aForm->cBox_LocName->Text = gLocList[cBox_LocChange->SelectedIndex]->mLocName;
			 aForm->tBox_ArtNo->Text = gLocList[cBox_LocChange->SelectedIndex]->mLocItemNo.ToString();
			 aForm->cBox_Manufacture->Text = gLocList[cBox_LocChange->SelectedIndex]->mLocManufacture;
			 aForm->tBox_Addr->Text = gLocList[cBox_LocChange->SelectedIndex]->mLocAddr.ToString();
			 aForm->ShowDialog(this);

			//ꂽ{^ʂ̏ 
			 if (aForm->DialogResult == System::Windows::Forms::DialogResult::OK) 
			 {
				 gLocList[cBox_LocChange->SelectedIndex]->mLocName = aForm->cBox_LocName->Text;
				 gLocList[cBox_LocChange->SelectedIndex]->mLocItemNo = int::Parse( aForm->tBox_ArtNo->Text);
				 gLocList[cBox_LocChange->SelectedIndex]->mLocManufacture = aForm->cBox_Manufacture->Text;
				 gLocList[cBox_LocChange->SelectedIndex]->mLocAddr = int::Parse(aForm->tBox_Addr->Text);
			 }

			 /* XgXV */
			 UpdateLocDisplay();

			 //tH[̉ 
			 delete aForm; 

		 }
private: System::Void button_NewLoc_Click(System::Object^  sender, System::EventArgs^  e) {
			 /* @֎ԐݒtH[J */
			 LocDBList^ aForm = gcnew LocDBList;

			 aForm->cBox_LocName->Text = "";
			 aForm->tBox_ArtNo->Text = "";
			 aForm->cBox_Manufacture->Text = "";
			 aForm->tBox_Addr->Text = "";
			 aForm->ShowDialog(this);

			//ꂽ{^ʂ̏ 
			 if (aForm->DialogResult == System::Windows::Forms::DialogResult::OK) 
			 {
				 LocData^ aItem = gcnew LocData();

				 aItem->mLocName = aForm->cBox_LocName->Text;
				 aItem->mLocItemNo = int::Parse( aForm->tBox_ArtNo->Text);
				 aItem->mLocManufacture = aForm->cBox_Manufacture->Text;
				 aItem->mLocAddr = int::Parse(aForm->tBox_Addr->Text);

				 gLocList->Add(aItem);
			 }

			 /* XgXV */
			 UpdateLocDisplay();

			 //tH[̉ 
			 delete aForm; 

		 }
private: System::Void button_DelLoc_Click(System::Object^  sender, System::EventArgs^  e) {

			 if( cBox_LocChange->Items->Count <= 1)
			 {

				 MessageBox::Show("Can't delete current loc. Need more than one loc data on this list.", "Attention", MessageBoxButtons::OK);
			 }
			 else
			 {
				 /* 폜\ȏꍇ */

				 if (MessageBox::Show("Would you accept to delete current loc data?", "Attention", MessageBoxButtons::YesNo) == System::Windows::Forms::DialogResult::Yes) {
					 gLocList->RemoveAt(cBox_LocChange->SelectedIndex);				
			
					 /* XgXV */
					 UpdateLocDisplay();
				  }
			  }


		 }
private: System::Void Form1_KeyDown(System::Object^  sender, System::Windows::Forms::KeyEventArgs^  e) {

			 if( ((e->KeyData & Keys::Up) == Keys::Up) && (gControlMode == POWER_ON))
			 {
				 AccelBar->Value = AccelBar->Value + 1;

			 }

			 if( ((e->KeyData & Keys::Down) == Keys::Down) && (gControlMode == POWER_ON))
			 {
				 AccelBar->Value = AccelBar->Value - 1;

			 }

		 }

private: System::Void button10_Click(System::Object^  sender, System::EventArgs^  e) {
			 /* KeyPad */

			 /* AhX */
			Button^ aButton = (Button^)sender; 
			int aTag;

			aTag = int::Parse(aButton->Tag->ToString());

			/* AhXXV */
			gTypedAddr = (gTypedAddr - ((gTypedAddr / 10) * 10)) * 10 + aTag;

			/* \ */
			label_Addr->Text = gTypedAddr.ToString();
		 }

private: System::Void button6021_F4_Click(System::Object^  sender, System::EventArgs^  e) {
			Button^ aButton = (Button^)sender; 
			int aTag;

			aTag = int::Parse(aButton->Tag->ToString());

			 /* I^l^Et@NV */
			RAILUINO_setLocoFunction(gTypedAddr, aTag, 1);

			//҂
			System::Threading::Thread::Sleep(1000);

			 /* ɐ؂ */
			RAILUINO_setLocoFunction(gTypedAddr, aTag, 0);

		 }

private: System::Void button6021_REV_Click(System::Object^  sender, System::EventArgs^  e) {

			Button^ aButton = (Button^)sender; 
			int aTag;

			aTag = int::Parse(aButton->Tag->ToString());
		
			 /* is */
			switch(aTag)
			{
				case 0: RAILUINO_setLocoDirection(gTypedAddr, DIRECTION_FWD); break;
				case 1: RAILUINO_setLocoDirection(gTypedAddr, DIRECTION_REV); break;
			}
		 }
private: System::Void AccBar_6021_Scroll(System::Object^  sender, System::EventArgs^  e) {
			 int aSpeed;

			 aSpeed = AccBar_6021->Value * 64;
			 
			 if( aSpeed > SPEED_MAX)
			 {
				 aSpeed = SPEED_MAX;
			 }
			 else if(aSpeed < 0)
			 {
				 aSpeed = 0;
			 }

			 /* xZbg */
			 RAILUINO_setLocoSpeed(gTypedAddr, aSpeed);

		 }
private: System::Void SButton_Loc_Click_1(System::Object^  sender, System::EventArgs^  e) {

			ToolStripButton^ aButton = (ToolStripButton^)sender; 
			int aTag;

			aTag = int::Parse(aButton->Tag->ToString());

			switch( aTag)
			{
			case 1:
				panel6021->Visible = false;
				listView1->Visible = true;
				listView1->Size = System::Drawing::Size(0, 0);
				break;

			case 2:
				panel6021->Visible = false;
				listView1->Location = Point(12, 32);
				listView1->Size = System::Drawing::Size(704, 347);
				listView1->Visible = true;
				break;

			case 3:
				panel6021->Visible = true;
				listView1->Visible = true;
				listView1->Size = System::Drawing::Size(0, 0);
				break;

			}


		 }
};


}

